' RaindropEeprom.spin
' Provides access to the 64KByte serial EEPROM.  The first 32K are used to hold the boot image.
' The second 32K can be used for user storage needs.

CON

PIN_SCL = 28
PIN_SDA = 29

OBJ

eeprom  : "Basic_I2C_Driver"

PUB Start
  eeprom.Initialize(PIN_SCL)

PUB WriteByte(data, address)
  eeprom.WriteByte(PIN_SCL, eeprom#EEPROM, address, data)

PUB WaitForWriteToFinish(address)
  repeat while eeprom.WriteWait(PIN_SCL, eeprom#EEPROM, address)

PUB ReadByte(address) : data
  return eeprom.ReadByte(PIN_SCL, eeprom#EEPROM, address)
  