' RaindropTest.spin

CON

_clkmode = xtal1 + pll16x
_xinfreq = 6_250_000

OBJ

leds            : "RaindropLeds"
display         : "RaindropDisplayFb"
buttons         : "RaindropButtons"
eeprom          : "RaindropEeprom"
fileSystem      : "RaindropFileSystem"
audio           : "RaindropAudio"

VAR

byte buffer[1024]

long bufferAddress
long writeCount
long readCount

PUB Start | a, i, numBytesRead, count
  leds.Start
  buttons.Start
  display.Start

  bufferAddress := @buffer
  writeCount := 0
  readCount := 0
  audio.Start(@bufferAddress)
   
  display.Box(0, 0, 127, 123, %000_111_11)
  display.PrintString(string("Ready."), 1, 0, %000_111_00)

  eeprom.Start
  eeprom.WriteByte($FC, $8001)
  eeprom.WaitForWriteToFinish($8001)
  a := eeprom.ReadByte($8001)
  display.PrintByte(a, 1, 32, %111_111_00)
  display.SetFlag(1)
   
  if true
    fileSystem.Start
    fileSystem.OpenForReading(string("test.txt"))
    fileSystem.Read(@buffer, 512)
    fileSystem.Close
    display.PrintString(@buffer, 1, 64, %000_000_11)

    fileSystem.OpenForReading(string("raindrop.raw"))
    fileSystem.Read(@buffer, 512)
    writeCount := 512
    repeat
      buttons.Read
      repeat while (writeCount - readCount) > 512
      numBytesRead := fileSystem.Read(bufferAddress + (writeCount & $3FF), 512)
      writeCount += 512
      if numBytesRead <> 512
        WordFill(bufferAddress + ((writeCount-(512-numBytesRead)) & $3FF), $0000, (512 - numBytesRead) >> 1)
        fileSystem.OpenForReading(string("unto.raw"))
      if buttons.WasPressed(buttons#MASK_ANY)
        quit
      display.SetFlag(1)
      leds.Led1(audio.AreHeadphonesPresent)
    fileSystem.Close

  leds.Led0(true)     
  repeat
    buttons.Read
    display.PrintWord(buttons.GetCurrentState, 1, 96-4, %000_111_00)
    display.SetFlag(1) 